{ Copyright 1996 - Raymond Allan }

unit Newcal;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Grids, Calendar, StdCtrls, Buttons;

type
  TWeekCal = class(TForm)
    Calendar1: TCalendar;
    ThisDay: TLabel;
    Lyear: TBitBtn;
    Nyear: TBitBtn;
    LMonth: TBitBtn;
    NMonth: TBitBtn;
    Today: TBitBtn;
    About: TBitBtn;
    Ok: TBitBtn;
    P1: TPanel;
    procedure Calendar1Change(Sender: TObject);
    procedure NyearClick(Sender: TObject);
    procedure LyearClick(Sender: TObject);
    procedure NMonthClick(Sender: TObject);
    procedure LMonthClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TodayClick(Sender: TObject);
    procedure OkClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WeekCal: TWeekCal;

implementation

{$R *.DFM}

procedure TWeekCal.FormCreate(Sender: TObject);
begin
ClientHeight:=P1.Height;
ClientWidth:=P1.Width;
Calendar1Change(Self);
end;


procedure TWeekCal.Calendar1Change(Sender: TObject);

const Dayof : array[1..7] of Byte=(6,7,8,9,10,4,5);

var FirstDate : Tdatetime;
    glx, WeekNumber : integer;
    gly, glm, gld : word;

begin
DecodeDate(Calendar1.CalendarDate,gly,glm,gld);
FirstDate:=EncodeDate(gly,1,1);
WeekNumber:=(trunc(Calendar1.CalendarDate)-trunc(FirstDate) + DayOf[DayOfWeek(FirstDate)])div 7;

{ If anyone can show me how to get rid of the following
  2 if statements, I would appreciate it. Although they both do the job. }

if weeknumber > 52 then weeknumber:=1;
if weeknumber < 1 then weeknumber:=1;
Caption := 'Week Number ' + IntToStr(WeekNumber);
ThisDay.Caption := FormatDateTime(LongDateFormat, Calendar1.CalendarDate);
end;

procedure TWeekCal.NyearClick(Sender: TObject);
begin
Calendar1.NextYear;
end;

procedure TWeekCal.LyearClick(Sender: TObject);
begin
Calendar1.PrevYear;
end;

procedure TWeekCal.NMonthClick(Sender: TObject);
begin
Calendar1.NextMonth;
end;

procedure TWeekCal.LMonthClick(Sender: TObject);
begin
Calendar1.PrevMonth;
end;



procedure TWeekCal.TodayClick(Sender: TObject);
var Year, Month, Day : Word;
begin

DecodeDate(Now, Year, Month, Day);

{ Set Day to 1, otherwise, when Month is set the calendar may
  try to highlight an invalid day - Month could be Feb, and
  day could be 31 }

Calendar1.Day := 1;
Calendar1.Year := Year;
Calendar1.Month := Month;
Calendar1.Day := Day;
end;

procedure TWeekCal.OkClick(Sender: TObject);
begin
close;
end;

procedure TWeekCal.AboutClick(Sender: TObject);
begin
MessageBox(Handle,
'Author:- Raymond Allan' +
#13'    (C) Copyright 1996' +
#13'' +
#13'You may use this program' +
#13'freely as long as you do' +
#13'not use it in a commercially' +
#13'based package without the' +
#13'authors consent.' +
#13'' +
#13'e:mail:' +
#13'raymond.allan@cableinet.com',
'Week Number Calendar',mb_Ok or mb_DefButton1)
end;

end.
